<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/iron-flex-layout/iron-flex-layout.html">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="food-icons.html">
<link rel="import" href="food-image.html">
<link rel="import" href="food-select.html">
<link rel="import" href="food-cart.html">
<link rel="import" href="../bower_components/paper-styles/element-styles/paper-material-styles.html">

<dom-module id="food-order">

  <template strip-whitespace>

     <style include=" paper-material-styles">
        
        :host{
            display: block;
            padding: 24px 16px;
            margin: 8px;
        }
        .paper-material {
          padding: 16px;
          margin: 0;
          display: inline-block;
        }
      
        .header h2 {
            color: #2196F3;
            text-transform: uppercase;
            font-weight: 400;
            font-size: 0.8rem;
        }
        
        h2 {
            color: darkslategray;
            /* text-transform: uppercase; */
            font-weight: 300;
            font-size: 0.8rem;
        }

        paper-collapse-item
        {
            background: white;
        }
        
        [name="order"][new] h2[name=number]
        {
            color: green;
        }

        [name="order"][cancelled] h2[name=number]
        {
            color: orange;
        }

       :host food-cart
      {
        max-height: 380px;
        overflow: auto;
      }
      #total
      { 
        font-weight: bold;
        text-align: right;
        margin-right: 10px;
      }
      .total-row
      {
        margin: 24px 0;
      }
      food-cart
      {
        --food-cart-header: {
          display: none;
        };
  
        --food-cart-total: {
          display: none;
        };
      }
        
    </style>
 

    <div name="order" class="layout vertical paper-material" elevation="1" new$=[[_orderIsNew(order.status)]] cancelled$=[[_orderIsCancelled(order.status)]]>                                   
        <div class="layout horizontal justified header">                                    
            <h2 name="number">Заказ [[order.number]]</h2><h2>[[_humanReadableTime(order.timestamp)]]</h2>
        </div> 
        <div class="layout horizontal justified header">                                    
            <h2>[[_status(order.status)]]</h2><h2>[[_orderPaymentState(order.pay, order.payment)]]</h2>
        </div> 
                              
        <paper-collapse-item icon="icons:payment" header="Ваша корзина ([[_getPluralizedQuantity(order.cart.length)]])" opened=[[!brief]] hidden$=[[small]]>
            <div class="layout horizontal justified">
                <h2>[[order.name]]</h2><h2>[[order.phone]]</h2>
            </div>  
            <div class="layout horizontal justified">                                
                <h2>[[order.address]]</h2>
            </div>
            <div class="layout horizontal justified">  
                <h2 class="header">Доставка</h2>
                <h2>[[_humanReadableTime(order.delivery)]]</h2>
            </div>
            <div class="layout horizontal justified">                          
                <h2>[[order.comment]]</h2>
            </div>
            <food-cart cart="[[order.cart]]" readonly ></food-cart>
        </paper-collapse-item>
            

        <div class="row total-row">
            
            <div id="discount" hidden$=[[!_hasDiscount(order.discount)]]>  
                Всего [[order.total]]
            </div>

            <div id="discount" hidden$=[[!_hasDiscount(order.discount)]]>    
                Скидка [[order.discount]]%
            </div>
            
            <div class="flex">[[_deliveryTotalLabel(order.payment,order.pay)]]</div>
            <div>[[_formatTotal(order.totalWithDiscount)]]</div>
        </div> 
      
      
                                            
        <div class="layout horizontal justified self-end" >                                    
            <paper-button raised on-tap="_cancelOrder" hidden$=[[!_orderIsNew(order.status)]]>
                Отменить заказ
            </paper-button>  
            <paper-button raised on-tap="_removeOrder" hidden$=[[!_orderIsCancelled(order.status)]]>
                Удалить
            </paper-button> 
        </div>
    </div>

  </template>

  <script>

    class FoodOrder extends Polymer.Element {

      static get is() { return 'food-order'; }

      static get properties() { return {

        order: Object,
        small: Boolean,
        brief: Boolean,
        readonly: {
          type: Boolean,
          reflectToAttribute: true,
          value: false
        }

      }}

      _status(status)
      {
        if(status === 'new')
            return 'Новый';
        if(status === 'cancelled')
            return 'Отменен';
      }

      _hasDiscount(discount)
      {
        return !!discount
      }

      _formatTotal(total) {

        return isNaN(total) ? '' : parseFloat(total).toFixed(2) + ' руб.';
      }

        _deliveryTotalLabel(payment, pay)
        {
            return payment==="completed" ? "Оплачено": "Всего к оплате";       
        }

      _orderIsNew(status)
      {
        return status === 'new'
      }
      _orderIsCancelled(status)
      {
        return status === 'cancelled'
      }

      _orderPaymentState(pay,payment)
      {
        return payment === 'completed' ? "Оплачено" : pay === 'delivery' ? "Оплата по доставке":"";
      }

      _formatPrice(total) {
        return isNaN(total) ? '' : total + ' руб.';//'$' + total.toFixed(2);
      }

      _getPluralizedQuantity(quantity) {
        return quantity + ' ' + (quantity === 1 ? 'позиция' : 'позиций');
      }

      _humanReadableTime(time)
      {
        return fecha.format(time, 'HH:mm DD MMMM YYYY');
      }

      _selectedPayment(payment)
      {
         return payment == 'delivery' ? "По доставке":"Исполнено"
      }
      _cancelOrder(e)
        {
            Meteor.call("cancelOrder", this.order._id);
        }
      _removeOrder(e)
      {
          Meteor.call("hideOrder", this.order._id);
      }

    }

    customElements.define(FoodOrder.is, FoodOrder);

  </script>

</dom-module>
